using FluentValidation;
using CMSMicroservice.Protobuf.Protos.UserWallet;
namespace CMSMicroservice.Protobuf.Validator.UserWallet;

public class CreateNewUserWalletRequestValidator : AbstractValidator<CreateNewUserWalletRequest>
{
    public CreateNewUserWalletRequestValidator()
    {
        RuleFor(model => model.UserId)
            .NotNull();
        RuleFor(model => model.Balance)
            .NotNull();
        RuleFor(model => model.NetworkBalance)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<CreateNewUserWalletRequest>.CreateWithOptions((CreateNewUserWalletRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
